/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use client";
"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const o=require("./Scheduler.js"),V=require("./constants/index.js"),u=require("./views/agenda/AgendaView.js"),l=require("./views/time/TimelineView.js"),d=require("./views/day/DayView.js"),c=require("./views/week/WeekView.js"),i=require("./views/week/WorkWeekView.js"),s=require("./views/month/MonthView.js"),O=require("./items/SchedulerItem.js"),_=require("./items/SchedulerItemContent.js"),S=require("./items/SchedulerViewItem.js"),h=require("./items/SchedulerProportionalViewItem.js"),n=require("./items/SchedulerEditItem.js"),a=require("./slots/SchedulerSlot.js"),C=require("./slots/SchedulerViewSlot.js"),m=require("./slots/SchedulerEditSlot.js"),f=require("./tasks/SchedulerTask.js"),I=require("./tasks/SchedulerViewTask.js"),E=require("./tasks/SchedulerEditTask.js"),D=require("./views/common/SchedulerDrag.js"),x=require("./views/common/SchedulerResize.js"),w=require("./components/SchedulerForm.js"),p=require("./editors/SchedulerFormEditor.js"),q=require("./components/SchedulerOccurrenceDialog.js"),R=require("./components/SchedulerRemoveDialog.js"),A=require("./components/header/SchedulerHeader.js"),T=require("./components/DateHeaderCell.js"),P=require("./components/TimeHeaderCell.js"),g=require("./components/footer/SchedulerFooter.js"),F=require("./items/hooks/use-drag-item.js"),k=require("./hooks/use-items-selection.js"),N=require("./items/hooks/use-remove-item.js"),v=require("./items/hooks/use-resize-item.js"),M=require("./items/hooks/use-series.js"),H=require("./items/hooks/use-show-occurrence-dialog.js"),W=require("./items/hooks/use-show-remove-item-dialog.js"),L=require("./hooks/use-slots-selection.js"),e=require("./context/SchedulerContext.js"),t=require("./context/SchedulerEditItemContext.js"),r=require("./context/SchedulerEditSlotContext.js"),z=require("./hooks/use-items-focus.js"),G=require("./hooks/use-slots-focus.js");exports.Scheduler=o.Scheduler;exports.schedulerDefaultProps=o.schedulerDefaultProps;exports.DATA_ACTION=V.DATA_ACTION;exports.AgendaView=u.AgendaView;exports.agendaViewDefaultProps=u.agendaViewDefaultProps;exports.TimelineView=l.TimelineView;exports.timeLineViewDefaultProps=l.timeLineViewDefaultProps;exports.DayView=d.DayView;exports.dayViewDefaultProps=d.dayViewDefaultProps;exports.WeekView=c.WeekView;exports.weekViewDefaultProps=c.weekViewDefaultProps;exports.WorkWeekView=i.WorkWeekView;exports.workWeekDefaultProps=i.workWeekDefaultProps;exports.MonthView=s.MonthView;exports.monthViewDefaultProps=s.monthViewDefaultProps;exports.SchedulerItem=O.SchedulerItem;exports.SchedulerItemContent=_.SchedulerItemContent;exports.SchedulerViewItem=S.SchedulerViewItem;exports.schedulerViewItemDefaultProps=S.schedulerViewItemDefaultProps;exports.SchedulerProportionalViewItem=h.SchedulerProportionalViewItem;exports.schedulerProportionalViewItemDefaultProps=h.schedulerProportionalViewItemDefaultProps;exports.SchedulerEditItem=n.SchedulerEditItem;exports.schedulerEditItemDefaultProps=n.schedulerEditItemDefaultProps;exports.SchedulerSlot=a.SchedulerSlot;exports.schedulerSlotDefaultProps=a.schedulerSlotDefaultProps;exports.SchedulerViewSlot=C.SchedulerViewSlot;exports.schedulerViewSlotDefaultProps=C.schedulerViewSlotDefaultProps;exports.SchedulerEditSlot=m.SchedulerEditSlot;exports.schedulerEditSlotDefaultProps=m.schedulerEditSlotDefaultProps;exports.SchedulerTask=f.SchedulerTask;exports.SchedulerViewTask=I.SchedulerViewTask;exports.schedulerViewTaskDefaultProps=I.schedulerViewTaskDefaultProps;exports.SchedulerEditTask=E.SchedulerEditTask;exports.schedulerEditTaskDefaultProps=E.schedulerEditTaskDefaultProps;exports.SchedulerDrag=D.SchedulerDrag;exports.schedulerDragDefaultProps=D.schedulerDragDefaultProps;exports.SchedulerResize=x.SchedulerResize;exports.schedulerResizeDefaultProps=x.schedulerResizeDefaultProps;exports.SchedulerForm=w.SchedulerForm;exports.schedulerFormDefaultProps=w.schedulerFormDefaultProps;exports.SchedulerFormEditor=p.SchedulerFormEditor;exports.schedulerFormEditorDefaultProps=p.schedulerFormEditorDefaultProps;exports.SchedulerOccurrenceDialog=q.SchedulerOccurrenceDialog;exports.SchedulerRemoveDialog=R.SchedulerRemoveDialog;exports.SchedulerHeader=A.SchedulerHeader;exports.DateHeaderCell=T.DateHeaderCell;exports.dateHeaderCellDefaultProps=T.dateHeaderCellDefaultProps;exports.TimeHeaderCell=P.TimeHeaderCell;exports.timeHeaderCellDefaultProps=P.timeHeaderCellDefaultProps;exports.SchedulerFooter=g.SchedulerFooter;exports.DRAG_ITEM_ACTION=F.DRAG_ITEM_ACTION;exports.ITEMS_SELECT_ACTION=k.ITEMS_SELECT_ACTION;exports.REMOVE_ITEM_ACTION=N.REMOVE_ITEM_ACTION;exports.RESIZE_ITEM_ACTION=v.RESIZE_ITEM_ACTION;exports.SERIES_ACTION=M.SERIES_ACTION;exports.SHOW_OCCURRENCE_DIALOG_ACTION=H.SHOW_OCCURRENCE_DIALOG_ACTION;exports.SHOW_REMOVE_DIALOG_ACTION=W.SHOW_REMOVE_DIALOG_ACTION;exports.SLOTS_SELECT_ACTION=L.SLOTS_SELECT_ACTION;exports.SchedulerActiveViewContext=e.SchedulerActiveViewContext;exports.SchedulerDataContext=e.SchedulerDataContext;exports.SchedulerDateContext=e.SchedulerDateContext;exports.SchedulerDateRangeContext=e.SchedulerDateRangeContext;exports.SchedulerFieldsContext=e.SchedulerFieldsContext;exports.SchedulerGroupsContext=e.SchedulerGroupsContext;exports.SchedulerOrientationContext=e.SchedulerOrientationContext;exports.SchedulerPropsContext=e.SchedulerPropsContext;exports.SchedulerViewsContext=e.SchedulerViewsContext;exports.useSchedulerActiveViewContext=e.useSchedulerActiveViewContext;exports.useSchedulerDataContext=e.useSchedulerDataContext;exports.useSchedulerDateContext=e.useSchedulerDateContext;exports.useSchedulerDateRangeContext=e.useSchedulerDateRangeContext;exports.useSchedulerFieldsContext=e.useSchedulerFieldsContext;exports.useSchedulerGroupsContext=e.useSchedulerGroupsContext;exports.useSchedulerOrientationContext=e.useSchedulerOrientationContext;exports.useSchedulerPropsContext=e.useSchedulerPropsContext;exports.useSchedulerViewsContext=e.useSchedulerViewsContext;exports.SchedulerEditItemDragItemContext=t.SchedulerEditItemDragItemContext;exports.SchedulerEditItemFormItemContext=t.SchedulerEditItemFormItemContext;exports.SchedulerEditItemPropsContext=t.SchedulerEditItemPropsContext;exports.SchedulerEditItemRemoveItemContext=t.SchedulerEditItemRemoveItemContext;exports.SchedulerEditItemResizeItemContext=t.SchedulerEditItemResizeItemContext;exports.SchedulerEditItemShowOccurrenceDialogContext=t.SchedulerEditItemShowOccurrenceDialogContext;exports.SchedulerEditItemShowRemoveDialogContext=t.SchedulerEditItemShowRemoveDialogContext;exports.useSchedulerEditItemDragItemContext=t.useSchedulerEditItemDragItemContext;exports.useSchedulerEditItemFormItemContext=t.useSchedulerEditItemFormItemContext;exports.useSchedulerEditItemPropsContext=t.useSchedulerEditItemPropsContext;exports.useSchedulerEditItemRemoveItemContext=t.useSchedulerEditItemRemoveItemContext;exports.useSchedulerEditItemResizeItemContext=t.useSchedulerEditItemResizeItemContext;exports.useSchedulerEditItemShowOccurrenceDialogContext=t.useSchedulerEditItemShowOccurrenceDialogContext;exports.useSchedulerEditItemShowRemoveDialogContext=t.useSchedulerEditItemShowRemoveDialogContext;exports.SchedulerEditSlotFormItemContext=r.SchedulerEditSlotFormItemContext;exports.SchedulerEditSlotPropsContext=r.SchedulerEditSlotPropsContext;exports.useSchedulerEditSlotFormItemContext=r.useSchedulerEditSlotFormItemContext;exports.useSchedulerEditSlotPropsContext=r.useSchedulerEditSlotPropsContext;exports.ITEMS_FOCUS_ACTION=z.ITEMS_FOCUS_ACTION;exports.SLOTS_FOCUS_ACTION=G.SLOTS_FOCUS_ACTION;
