/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const zt=require("react"),Ut=require("../components/SchedulerOccurrenceDialog.js"),Ht=require("../components/SchedulerForm.js"),xt=require("../components/SchedulerRemoveDialog.js"),h=require("@progress/kendo-react-common"),Wt=require("../views/common/SchedulerDrag.js"),Vt=require("../views/common/SchedulerResize.js"),Bt=require("./SchedulerViewItem.js"),Kt=require("../context/SchedulerEditItemContext.js"),_=require("./hooks/use-form-item.js"),E=require("./hooks/use-show-occurrence-dialog.js"),u=require("./hooks/use-remove-item.js"),d=require("./hooks/use-show-remove-item-dialog.js"),C=require("./hooks/use-drag-item.js"),I=require("./hooks/use-resize-item.js"),y=require("./hooks/use-series.js"),m=require("../hooks/use-items-selection.js"),B=require("../context/SchedulerViewContext.js"),K=require("../hooks/use-items-focus.js"),qt=require("../context/SchedulerContext.js"),Zt=require("../hooks/useEditable.js"),g=require("../hooks/use-slots-focus.js");function Pt(t){const l=Object.create(null,{[Symbol.toStringTag]:{value:"Module"}});if(t){for(const s in t)if(s!=="default"){const G=Object.getOwnPropertyDescriptor(t,s);Object.defineProperty(l,s,G.get?G:{enumerable:!0,get:()=>t[s]})}}return l.default=t,Object.freeze(l)}const n=Pt(zt),Ue=n.forwardRef((t,l)=>{const{_ref:s,itemRef:G,onDataAction:p,ignoreIsAllDay:z,viewItem:He,series:xe,onSeriesChange:We,form:Ve,formItem:Be,onFormItemChange:Ke,drag:qe,dragItem:Ze,onDragItemChange:Pe,resize:Xe,resizeItem:Ye,onResizeItemChange:je,removeDialog:Je,removeItem:Qe,onRemoveItemChange:$e,occurrenceDialog:et,showOccurrenceDialog:tt,onShowOccurrenceDialogChange:rt,showRemoveDialog:ot,onShowRemoveDialogChange:at,onFocus:q,onFocusAction:Z,onMouseDown:P,onMouseDownAction:X,onMouseUp:Y,onMouseUpAction:j,onClick:J,onClickAction:Q,onDoubleClick:$,onDoubleClickAction:ee,onRemoveClick:te,onRemoveClickAction:re,onPress:oe,onPressAction:ae,onDrag:le,onDragAction:ie,onRelease:ne,onReleaseAction:ce,onResizePress:se,onResizePressAction:Ie,onResizeStartDrag:Ee,onResizeStartDragAction:Ce,onResizeEndDrag:Oe,onResizeEndDragAction:_e,onResizeRelease:me,onResizeReleaseAction:Ae,onOccurrenceClick:de,onOccurrenceClickAction:ue,onSeriesClick:ye,onSeriesClickAction:Te,onKeyDown:Se,onKeyDownAction:Re,onKeyUp:ge,onKeyUpAction:fe,onRemoveConfirm:Ne,onRemoveConfirmAction:De,onFormSubmit:Me,onFormSubmitAction:he,onCancel:ve,onCancelAction:be}={...R,...t},[lt,it]=n.useState(t.tabIndex),Ge=n.useRef(null),i=n.useRef(null),nt=h.useId();n.useImperativeHandle(Ge,()=>({props:t,element:i.current&&i.current.element})),n.useImperativeHandle(l,()=>Ge.current),n.useImperativeHandle(s,()=>i.current),n.useImperativeHandle(G,()=>i.current);const we=He||R.viewItem,pe=qe||R.drag,ze=Xe||R.resize,ct=Ve||R.form,st=et||R.occurrenceDialog,It=Je||R.removeDialog,U=Zt.useEditable(t.editable),[H,f]=B.useSchedulerViewSelectedItemsContext(),[x,,W]=y.useSeries(null,xe,We),[v,Et,b]=_.useFormItem({series:x,onDataAction:p},[null,Be,Ke]),[T,Ct,A]=C.useDragItem({dataItem:t.dataItem,ignoreIsAllDay:t.ignoreIsAllDay,isAllDay:t.isAllDay,onDataAction:p},[null,Ze,Pe]),[S,Ot,O]=I.useResizeItem({dataItem:t.dataItem,onDataAction:p},[null,Ye,je]),[N,_t,w]=u.useRemoveItem({series:x,onDataAction:p},[null,Qe,$e]),[V,mt,D]=d.useShowRemoveDialog(!1,ot,at),[k,At,M]=E.useShowOccurrenceDialog(!1,tt,rt),[ke]=B.useSchedulerViewItemsContext(),[,Le]=B.useSchedulerViewFocusedItemsContext(),[,L]=B.useSchedulerViewFocusedSlotsContext(),Fe=!!(i.current&&H&&H.some(r=>r.current===i.current)),c=n.useMemo(()=>({selected:Fe,series:x,formItem:v,dragItem:T,resizeItem:S,removeItem:N,showRemoveDialog:V,showOccurrenceDialog:k}),[T,v,N,S,Fe,x,k,V]),a=n.useMemo(()=>({[y.SERIES_ACTION.set]:W,[y.SERIES_ACTION.toggle]:W,[y.SERIES_ACTION.reset]:W,[m.ITEMS_SELECT_ACTION.select]:f,[m.ITEMS_SELECT_ACTION.add]:f,[m.ITEMS_SELECT_ACTION.remove]:f,[m.ITEMS_SELECT_ACTION.reset]:f,[m.ITEMS_SELECT_ACTION.selectNext]:f,[m.ITEMS_SELECT_ACTION.selectPrev]:f,[_.FORM_ITEM_ACTION.set]:b,[_.FORM_ITEM_ACTION.setMaster]:b,[_.FORM_ITEM_ACTION.reset]:b,[_.FORM_ITEM_ACTION.complete]:b,[u.REMOVE_ITEM_ACTION.set]:w,[u.REMOVE_ITEM_ACTION.reset]:w,[u.REMOVE_ITEM_ACTION.complete]:w,[E.SHOW_OCCURRENCE_DIALOG_ACTION.close]:M,[E.SHOW_OCCURRENCE_DIALOG_ACTION.open]:M,[E.SHOW_OCCURRENCE_DIALOG_ACTION.set]:M,[E.SHOW_OCCURRENCE_DIALOG_ACTION.toggle]:M,[E.SHOW_OCCURRENCE_DIALOG_ACTION.reset]:M,[d.SHOW_REMOVE_DIALOG_ACTION.close]:D,[d.SHOW_REMOVE_DIALOG_ACTION.open]:D,[d.SHOW_REMOVE_DIALOG_ACTION.set]:D,[d.SHOW_REMOVE_DIALOG_ACTION.toggle]:D,[d.SHOW_REMOVE_DIALOG_ACTION.reset]:D,[C.DRAG_ITEM_ACTION.start]:A,[C.DRAG_ITEM_ACTION.drag]:A,[C.DRAG_ITEM_ACTION.complete]:A,[C.DRAG_ITEM_ACTION.completeOccurrence]:A,[C.DRAG_ITEM_ACTION.completeSeries]:A,[C.DRAG_ITEM_ACTION.set]:A,[C.DRAG_ITEM_ACTION.reset]:A,[C.DRAG_ITEM_ACTION.dragSelected]:A,[I.RESIZE_ITEM_ACTION.start]:O,[I.RESIZE_ITEM_ACTION.startDrag]:O,[I.RESIZE_ITEM_ACTION.startDragSelected]:O,[I.RESIZE_ITEM_ACTION.endDrag]:O,[I.RESIZE_ITEM_ACTION.endDragSelected]:O,[I.RESIZE_ITEM_ACTION.complete]:O,[I.RESIZE_ITEM_ACTION.completeOccurrence]:O,[I.RESIZE_ITEM_ACTION.completeSeries]:O,[I.RESIZE_ITEM_ACTION.set]:O,[I.RESIZE_ITEM_ACTION.reset]:O,[K.ITEMS_FOCUS_ACTION.next]:Le,[K.ITEMS_FOCUS_ACTION.prev]:Le,[g.SLOTS_FOCUS_ACTION.left]:L,[g.SLOTS_FOCUS_ACTION.right]:L,[g.SLOTS_FOCUS_ACTION.up]:L,[g.SLOTS_FOCUS_ACTION.down]:L,null:()=>{}}),[A,b,f,w,O,W,M,D,Le,L]),dt=n.useCallback(r=>{if(Z){const e=Z(r,t,c);e&&(Array.isArray(e)?e.filter(Boolean).map(o=>o&&a[o.type]({...o,item:i},r)):a[e.type]({...e,item:i}))}q&&q.call(void 0,r)},[a,q,Z,t,c]),ut=n.useCallback(r=>{if(X){const e=X(r,t,c);e&&(Array.isArray(e)?e.filter(Boolean).map(o=>o&&a[o.type]({...o,item:i},r)):a[e.type]({...e,item:i}))}P&&P.call(void 0,r)},[a,P,X,t,c]),yt=n.useCallback(r=>{if(j){const e=j(r,t,c);e&&(Array.isArray(e)?e.filter(Boolean).map(o=>o&&a[o.type]({...o,item:i},r)):a[e.type]({...e,item:i}))}Y&&Y.call(void 0,r)},[a,Y,j,t,c]),[,Tt]=n.useContext(qt.SchedulerItemSelectionContext),St=n.useCallback(r=>{if(Q){Tt(i.current);const e=Q(r,t,c);e&&(Array.isArray(e)?e.filter(Boolean).map(o=>o&&a[o.type]({...o,item:i},r)):a[e.type]({...e,item:i}))}J&&J.call(void 0,r)},[a,J,Q,t,c]),Rt=n.useCallback(r=>{if(ee){const e=ee(r,t,c);e&&(Array.isArray(e)?e.filter(Boolean).map(o=>o&&a[o.type]({...o,item:i},r)):a[e.type]({...e,item:i}))}$&&$.call(void 0,r)},[ee,$,t,a,c]),gt=n.useCallback(r=>{if(re){const e=re(r,t,c);e&&(Array.isArray(e)?e.filter(Boolean).map(o=>o&&a[o.type]({...o,item:i},r)):a[e.type]({...e,item:i}))}te&&te.call(void 0,r)},[re,te,t,a,c]),ft=n.useCallback(r=>{if(ae){const e=ae(r,t,c);e&&(Array.isArray(e)?e.filter(Boolean).map(o=>o&&a[o.type]({...o,item:i},r)):a[e.type]({...e,item:i},r))}oe&&oe.call(void 0,r)},[ae,oe,t,a,c]),Nt=n.useCallback(r=>{if(ie){const e=ie(r,t,c);e&&(Array.isArray(e)?e.filter(Boolean).map(o=>o&&a[o.type]({...o,item:i},r.dragEvent.originalEvent)):a[e.type]({...e,item:i},r.dragEvent.originalEvent))}le&&le.call(void 0,r)},[ie,le,t,a,c]),Dt=n.useCallback(r=>{if(ce){const e=ce(r,t,c);e&&(Array.isArray(e)?e.filter(Boolean).map(o=>o&&a[o.type]({...o,item:i},r.dragEvent.originalEvent)):a[e.type]({...e,item:i},r.dragEvent.originalEvent))}ne&&ne.call(void 0,r)},[ce,ne,t,a,c]),Mt=n.useCallback(r=>{if(Ie){const e=Ie(r,t,c);e&&(Array.isArray(e)?e.filter(Boolean).map(o=>o&&a[o.type]({...o,item:i},r.dragEvent.originalEvent)):a[e.type]({...e,item:i},r.dragEvent.originalEvent))}se&&se.call(void 0,r)},[Ie,se,t,c,a]),ht=n.useCallback(r=>{if(Ce){const e=Ce(r,t,c);e&&(Array.isArray(e)?e.filter(Boolean).map(o=>o&&a[o.type]({...o,item:i},r.dragEvent.originalEvent)):a[e.type]({...e,item:i},r.dragEvent.originalEvent))}Ee&&Ee.call(void 0,r)},[Ee,Ce,t,a,c]),vt=n.useCallback(r=>{if(_e){const e=_e(r,t,c);e&&(Array.isArray(e)?e.filter(Boolean).map(o=>o&&a[o.type]({...o,item:i},r.dragEvent.originalEvent)):a[e.type]({...e,item:i},r.dragEvent.originalEvent))}Oe&&Oe.call(void 0,r)},[Oe,_e,t,a,c]),bt=n.useCallback(r=>{if(Ae){const e=Ae(r,t,c);e&&(Array.isArray(e)?e.filter(Boolean).map(o=>o&&a[o.type]({...o,item:i},r.dragEvent.originalEvent)):a[e.type]({...e,item:i},r.dragEvent.originalEvent))}me&&me.call(void 0,r)},[Ae,me,t,a,c]),wt=n.useCallback(r=>{if(he){const e=he(r,t,c);e&&(Array.isArray(e)?e.filter(Boolean).map(o=>o&&a[o.type]({...o,item:i},r)):a[e.type]({...e,item:i},r))}Me&&Me.call(void 0,r)},[he,Me,t,c,a]),F=n.useCallback(r=>{if(be){const e=be(r,t,c);e&&(Array.isArray(e)?e.filter(Boolean).map(o=>o&&a[o.type]({...o,item:i},r)):a[e.type]({...e,item:i},r))}ve&&ve.call(void 0,r)},[be,ve,t,c,a]),kt=n.useCallback(r=>{if(ue){const e=ue(r,t,c);e&&(Array.isArray(e)?e.filter(Boolean).map(o=>o&&a[o.type]({...o,item:i},r)):a[e.type]({...e,item:i},r))}de&&de.call(void 0,r)},[ue,de,t,c,a]),Lt=n.useCallback(r=>{if(Te){const e=Te(r,t,c);e&&(Array.isArray(e)?e.filter(Boolean).map(o=>o&&a[o.type]({...o,item:i},r)):a[e.type]({...e,item:i},r))}ye&&ye.call(void 0,r)},[Te,ye,t,c,a]),Ft=n.useCallback(r=>{if(Re){const e=Re(r,t,c);e&&(Array.isArray(e)?e.filter(Boolean).map(o=>o&&a[o.type]({...o,item:i},r.syntheticEvent)):a[e.type]({...e,item:i},r.syntheticEvent))}Se&&Se.call(void 0,r)},[Re,Se,t,c,a]),Gt=n.useCallback(r=>{if(fe){const e=fe(r,t,c);e&&(Array.isArray(e)?e.filter(Boolean).map(o=>o&&a[o.type]({...o,item:i},r.syntheticEvent)):a[e.type]({...e,item:i},r.syntheticEvent))}ge&&ge.call(void 0,r)},[fe,ge,t,c,a]),pt=n.useCallback(r=>{if(De){const e=De(r,t,c);e&&(Array.isArray(e)?e.filter(Boolean).map(o=>o&&a[o.type]({...o,item:i},r.syntheticEvent)):a[e.type]({...e,item:i},r.syntheticEvent))}Ne&&Ne.call(void 0,r)},[De,Ne,t,c,a]);return n.useEffect(()=>{const r=ke.length&&ke[0].current===i.current;it(t.tabIndex!==void 0?t.tabIndex===null?void 0:t.tabIndex:H.length===0&&r?0:void 0)},[ke,t.tabIndex,H.length]),n.createElement(Kt.SchedulerEditItemContext,{props:t,form:[v,Et,b],drag:[T,Ct,A],resize:[S,Ot,O],remove:[N,_t,w],showRemoveDialog:[V,mt,D],showOccurrenceDialog:[k,At,M]},n.createElement(we,{...t,_ref:i,itemRef:i,selected:Fe,tabIndex:lt,id:nt,onKeyDown:Ft,onKeyUp:Gt,onFocus:dt,onMouseUp:yt,onMouseDown:ut,onClick:St,onDoubleClick:Rt,onRemoveClick:gt,onPress:ft,onDrag:Nt,onRelease:Dt,onResizePress:Mt,onResizeEndDrag:vt,onResizeStartDrag:ht,onResizeRelease:bt}),T&&U.drag&&(Array.isArray(T)?T.map((r,e)=>n.createElement(pe,{key:e,ignoreIsAllDay:z,dataItem:r,vertical:t.vertical,viewItem:we,item:t.item})):n.createElement(pe,{ignoreIsAllDay:z,dataItem:T,vertical:t.vertical,viewItem:we,item:t.item})),S&&U.resize&&(Array.isArray(S)?S.map((r,e)=>n.createElement(ze,{key:e,format:t.format,ignoreIsAllDay:z,dataItem:r,viewItem:t.viewItem,item:t.item,vertical:t.vertical})):n.createElement(ze,{format:t.format,ignoreIsAllDay:z,dataItem:S,viewItem:t.viewItem,item:t.item,vertical:t.vertical})),v&&!k&&U.edit&&n.createElement(ct,{dataItem:v,onSubmit:wt,onClose:F,onCancel:F}),k&&n.createElement(st,{dataItem:v||T||S||N,isRemove:N!==null,onClose:F,onOccurrenceClick:kt,onSeriesClick:Lt}),V&&N&&U.remove&&n.createElement(It,{dataItem:N,onClose:F,onCancel:F,onConfirm:pt}))}),R={viewItem:Bt.SchedulerViewItem,drag:Wt.SchedulerDrag,resize:Vt.SchedulerResize,form:Ht.SchedulerForm,occurrenceDialog:Ut.SchedulerOccurrenceDialog,removeDialog:xt.SchedulerRemoveDialog,onClickAction:(t,l,s)=>[{type:t.syntheticEvent.metaKey||t.syntheticEvent.ctrlKey?s.selected&&!s.dragItem&&!s.resizeItem?m.ITEMS_SELECT_ACTION.remove:m.ITEMS_SELECT_ACTION.add:m.ITEMS_SELECT_ACTION.select}],onDoubleClickAction:(t,l)=>l.editable?[{type:_.FORM_ITEM_ACTION.set,payload:l.dataItem},l.isRecurring&&{type:E.SHOW_OCCURRENCE_DIALOG_ACTION.open}].filter(Boolean):[],onRemoveClickAction:(t,l)=>l.editable?[{type:u.REMOVE_ITEM_ACTION.set,payload:l.dataItem},l.isRecurring?{type:E.SHOW_OCCURRENCE_DIALOG_ACTION.open}:{type:d.SHOW_REMOVE_DIALOG_ACTION.open}]:[],onPressAction:(t,l)=>l.editable?{type:C.DRAG_ITEM_ACTION.start,payload:{x:t.dragEvent.clientX,y:t.dragEvent.clientY}}:[],onDragAction:(t,l)=>l.editable?{type:t.dragEvent.originalEvent.metaKey||t.dragEvent.originalEvent.ctrlKey?C.DRAG_ITEM_ACTION.dragSelected:C.DRAG_ITEM_ACTION.drag,payload:{x:t.dragEvent.clientX,y:t.dragEvent.clientY}}:[],onReleaseAction:(t,l,s)=>l.editable&&s.dragItem?l.isRecurring&&!l.isException&&s.series===null?{type:E.SHOW_OCCURRENCE_DIALOG_ACTION.open}:{type:l.isRecurring?s.series?C.DRAG_ITEM_ACTION.completeSeries:C.DRAG_ITEM_ACTION.completeOccurrence:C.DRAG_ITEM_ACTION.complete,payload:{x:t.dragEvent.clientX,y:t.dragEvent.clientY}}:[],onResizePressAction:(t,l)=>l.editable?{type:I.RESIZE_ITEM_ACTION.start,payload:{x:t.dragEvent.clientX,y:t.dragEvent.clientY}}:[],onResizeStartDragAction:(t,l)=>l.editable?{type:t.dragEvent.originalEvent.metaKey||t.dragEvent.originalEvent.ctrlKey?I.RESIZE_ITEM_ACTION.startDragSelected:I.RESIZE_ITEM_ACTION.startDrag,payload:{x:t.dragEvent.clientX,y:t.dragEvent.clientY}}:[],onResizeEndDragAction:(t,l)=>l.editable?{type:t.dragEvent.originalEvent.metaKey||t.dragEvent.originalEvent.ctrlKey?I.RESIZE_ITEM_ACTION.endDragSelected:I.RESIZE_ITEM_ACTION.endDrag,payload:{x:t.dragEvent.clientX,y:t.dragEvent.clientY}}:[],onResizeReleaseAction:(t,l,s)=>l.editable&&s.resizeItem?l.isRecurring&&!l.isException&&s.series===null?{type:E.SHOW_OCCURRENCE_DIALOG_ACTION.open}:{type:l.isRecurring?s.series?I.RESIZE_ITEM_ACTION.completeSeries:I.RESIZE_ITEM_ACTION.completeOccurrence:I.RESIZE_ITEM_ACTION.complete,payload:{x:t.dragEvent.clientX,y:t.dragEvent.clientY}}:[],onOccurrenceClickAction:(t,l,s)=>s.dragItem?[{type:C.DRAG_ITEM_ACTION.completeOccurrence},{type:E.SHOW_OCCURRENCE_DIALOG_ACTION.close}]:s.resizeItem?[{type:I.RESIZE_ITEM_ACTION.completeOccurrence},{type:E.SHOW_OCCURRENCE_DIALOG_ACTION.close}]:s.formItem?[{type:y.SERIES_ACTION.set,payload:!1},{type:_.FORM_ITEM_ACTION.set,payload:l.dataItem},{type:E.SHOW_OCCURRENCE_DIALOG_ACTION.close}]:s.removeItem?[{type:y.SERIES_ACTION.set,payload:!1},{type:u.REMOVE_ITEM_ACTION.set,payload:l.dataItem},{type:d.SHOW_REMOVE_DIALOG_ACTION.open},{type:E.SHOW_OCCURRENCE_DIALOG_ACTION.close}]:[],onSeriesClickAction:(t,l,s)=>s.dragItem?[{type:C.DRAG_ITEM_ACTION.completeSeries},{type:E.SHOW_OCCURRENCE_DIALOG_ACTION.close}]:s.resizeItem?[{type:I.RESIZE_ITEM_ACTION.completeSeries},{type:E.SHOW_OCCURRENCE_DIALOG_ACTION.close}]:s.formItem?[{type:y.SERIES_ACTION.set,payload:!0},{type:_.FORM_ITEM_ACTION.setMaster,payload:l.dataItem},{type:E.SHOW_OCCURRENCE_DIALOG_ACTION.close}]:s.removeItem?[{type:y.SERIES_ACTION.set,payload:!0},{type:u.REMOVE_ITEM_ACTION.set,payload:l.dataItem},{type:d.SHOW_REMOVE_DIALOG_ACTION.open},{type:E.SHOW_OCCURRENCE_DIALOG_ACTION.close}]:[],onKeyDownAction:(t,l)=>{switch(t.syntheticEvent.keyCode){case h.Keys.enter:return[{type:_.FORM_ITEM_ACTION.set,payload:l.dataItem},l.isRecurring&&{type:E.SHOW_OCCURRENCE_DIALOG_ACTION.open}];case h.Keys.tab:return[{type:t.syntheticEvent.shiftKey?K.ITEMS_FOCUS_ACTION.prev:K.ITEMS_FOCUS_ACTION.next,ignoreIsAllDay:l.ignoreIsAllDay},{type:t.syntheticEvent.shiftKey?m.ITEMS_SELECT_ACTION.selectPrev:m.ITEMS_SELECT_ACTION.selectNext,ignoreIsAllDay:l.ignoreIsAllDay}];case h.Keys.up:return[!!(l.slots.length&&l.slots[0]._ref.current)&&{type:g.SLOTS_FOCUS_ACTION.up,slot:l.slots[0]._ref}];case h.Keys.right:return[!!(l.slots.length&&l.slots[0]._ref.current)&&{type:g.SLOTS_FOCUS_ACTION.right,slot:l.slots[0]._ref}];case h.Keys.down:return[!!(l.slots.length&&l.slots[l.slots.length-1]._ref.current)&&{type:g.SLOTS_FOCUS_ACTION.down,slot:l.slots[l.slots.length-1]._ref}];case h.Keys.left:return[!!(l.slots.length&&l.slots[0]._ref.current)&&{type:g.SLOTS_FOCUS_ACTION.left,slot:l.slots[0]._ref}];default:return}},onFormSubmitAction:t=>[{type:_.FORM_ITEM_ACTION.complete,payload:t.value}],onRemoveConfirmAction:()=>[{type:u.REMOVE_ITEM_ACTION.complete},{type:E.SHOW_OCCURRENCE_DIALOG_ACTION.close}],onCancelAction:()=>[{type:y.SERIES_ACTION.reset},{type:u.REMOVE_ITEM_ACTION.reset},{type:_.FORM_ITEM_ACTION.reset},{type:C.DRAG_ITEM_ACTION.reset},{type:I.RESIZE_ITEM_ACTION.reset},{type:d.SHOW_REMOVE_DIALOG_ACTION.reset},{type:E.SHOW_OCCURRENCE_DIALOG_ACTION.reset}]};Ue.displayName="KendoReactSchedulerEditItem";exports.SchedulerEditItem=Ue;exports.schedulerEditItemDefaultProps=R;
