/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const e="scheduler.allEvents",r="scheduler.allDay",t="scheduler.today",n="scheduler.timelineViewTitle",c="scheduler.weekViewTitle",i="scheduler.workWeekViewTitle",o="scheduler.agendaViewTitle",d="scheduler.dayViewTitle",s="scheduler.monthViewTitle",l="scheduler.deleteTitle",u="scheduler.previousTitle",a="scheduler.nextTitle",E="scheduler.showFullDay",y="scheduler.showWorkDay",h="scheduler.editOccurrence",v="scheduler.editSeries",T="scheduler.editRecurringConfirmation",D="scheduler.editRecurringDialogTitle",f="scheduler.editSave",m="scheduler.editCancel",R="scheduler.editorTitle",k="scheduler.editorEventTitle",p="scheduler.editorEventStart",O="scheduler.editorEventStartTimeZone",W="scheduler.editorEventEnd",w="scheduler.editorEventEndTimeZone",S="scheduler.editorEventAllDay",g="scheduler.editorEventDescription",F="scheduler.editorEventSeparateTimeZones",V="scheduler.editorEventTimeZone",q="scheduler.recurrenceEditorRepeat",M="scheduler.recurrenceEditorDailyInterval",P="scheduler.recurrenceEditorDailyRepeatEvery",Y="scheduler.recurrenceEditorWeeklyInterval",Z="scheduler.recurrenceEditorWeeklyRepeatEvery",I="scheduler.recurrenceEditorWeeklyRepeatOn",C="scheduler.recurrenceEditorMonthlyDay",A="scheduler.recurrenceEditorMonthlyInterval",b="scheduler.recurrenceEditorMonthlyRepeatEvery",N="scheduler.recurrenceEditorMonthlyRepeatOn",L="scheduler.recurrenceEditorYearlyOf",x="scheduler.recurrenceEditorYearlyRepeatEvery",j="scheduler.recurrenceEditorYearlyRepeatOn",z="scheduler.recurrenceEditorYearlyInterval",B="scheduler.recurrenceEditorFrequenciesDaily",G="scheduler.recurrenceEditorFrequenciesMonthly",H="scheduler.recurrenceEditorFrequenciesNever",J="scheduler.recurrenceEditorFrequenciesWeekly",K="scheduler.recurrenceEditorFrequenciesYearly",Q="scheduler.recurrenceEditorOffsetPositionsFirst",U="scheduler.recurrenceEditorOffsetPositionsSecond",X="scheduler.recurrenceEditorOffsetPositionsThird",_="scheduler.recurrenceEditorOffsetPositionsFourth",$="scheduler.recurrenceEditorOffsetPositionsLast",ee="scheduler.recurrenceEditorWeekdaysDay",re="scheduler.recurrenceEditorWeekdaysWeekday",te="scheduler.recurrenceEditorWeekdaysWeekendday",ne="scheduler.recurrenceEditorEndAfter",ce="scheduler.recurrenceEditorEndOccurrence",ie="scheduler.recurrenceEditorEndLabel",oe="scheduler.recurrenceEditorEndNever",de="scheduler.recurrenceEditorEndOn",se="scheduler.editorDelete",le="scheduler.deleteConfirmation",ue="scheduler.deleteRecurringConfirmation",ae="scheduler.deleteOccurrence",Ee="scheduler.deleteSeries",ye="scheduler.deleteDialogTitle",he="scheduler.deleteRecurringDialogTitle",ve="scheduler.dateTitle",Te="scheduler.timeTitle",De="scheduler.eventTitle",fe="scheduler.editorValidationRequired",me="scheduler.editorValidationStart",Re="scheduler.editorValidationEnd",ke="scheduler.noEvents",pe="scheduler.moreEvents",Oe={[fe]:"Field is required.",[me]:"Start time must be before End time.",[Re]:"End time must be after Start time.",[e]:"All events",[r]:"all day",[t]:"Today",[d]:"Day",[s]:"Month",[c]:"Week",[i]:"Work Week",[n]:"Timeline",[o]:"Agenda",[l]:"Delete",[u]:"Previous",[a]:"Next",[E]:"Show full day",[y]:"Show business hours",[h]:"Edit current occurrence",[v]:"Edit the series",[T]:"Do you want to edit only this event occurrence or the whole series?",[D]:"Edit Recurring Item",[f]:"Save",[m]:"Cancel",[se]:"Delete",[R]:"Event",[k]:"Title",[p]:"Start",[O]:"Start Time Zone",[W]:"End",[w]:"End Time Zone",[S]:"All Day Event",[g]:"Description",[F]:"End in different Time Zone",[V]:"Specify Time Zone",[q]:"Repeat",[M]:"day(s)",[P]:"Repeat every",[Y]:"week(s)",[Z]:"Repeat every",[I]:"Repeat on",[C]:"Day",[A]:"month(s)",[b]:"Repeat every",[N]:"Repeat on",[L]:"of",[x]:"Repeat every",[j]:"Repeat on",[z]:"year(s)",[B]:"Daily",[G]:"Monthly",[H]:"Never",[J]:"Weekly",[K]:"Yearly",[Q]:"First",[U]:"Second",[X]:"Third",[_]:"Fourth",[$]:"Last",[ee]:"Day",[re]:"Weekday",[te]:"Weekend Day",[ne]:"After",[ce]:"occurrence(s)",[ie]:"End",[oe]:"Never",[de]:"On",[le]:"Are you sure you want to delete this event?",[ue]:"Do you want to delete only this event occurrence or the whole series?",[ae]:"Delete current occurrence",[Ee]:"Delete the series",[ye]:"Delete Event",[he]:"Delete Recurring Item",[ve]:"Date",[Te]:"Time",[De]:"Event",[ke]:"no events",[pe]:"More events"};exports.agendaViewTitle=o;exports.allDay=r;exports.allEvents=e;exports.dateTitle=ve;exports.dayViewTitle=d;exports.deleteConfirmation=le;exports.deleteDialogTitle=ye;exports.deleteOccurrence=ae;exports.deleteRecurringConfirmation=ue;exports.deleteRecurringDialogTitle=he;exports.deleteSeries=Ee;exports.deleteTitle=l;exports.editorCancel=m;exports.editorDelete=se;exports.editorEventAllDay=S;exports.editorEventDescription=g;exports.editorEventEnd=W;exports.editorEventEndTimeZone=w;exports.editorEventSeparateTimeZones=F;exports.editorEventStart=p;exports.editorEventStartTimeZone=O;exports.editorEventTimeZone=V;exports.editorEventTitle=k;exports.editorOccurrence=h;exports.editorRecurringConfirmation=T;exports.editorRecurringDialogTitle=D;exports.editorSave=f;exports.editorSeries=v;exports.editorTitle=R;exports.editorValidationEnd=Re;exports.editorValidationRequired=fe;exports.editorValidationStart=me;exports.eventTitle=De;exports.messages=Oe;exports.monthViewTitle=s;exports.moreEvents=pe;exports.nextTitle=a;exports.noEvents=ke;exports.previousTitle=u;exports.recurrenceEditorDailyInterval=M;exports.recurrenceEditorDailyRepeatEvery=P;exports.recurrenceEditorEndAfter=ne;exports.recurrenceEditorEndLabel=ie;exports.recurrenceEditorEndNever=oe;exports.recurrenceEditorEndOccurrence=ce;exports.recurrenceEditorEndOn=de;exports.recurrenceEditorFrequenciesDaily=B;exports.recurrenceEditorFrequenciesMonthly=G;exports.recurrenceEditorFrequenciesNever=H;exports.recurrenceEditorFrequenciesWeekly=J;exports.recurrenceEditorFrequenciesYearly=K;exports.recurrenceEditorMonthlyDay=C;exports.recurrenceEditorMonthlyInterval=A;exports.recurrenceEditorMonthlyRepeatEvery=b;exports.recurrenceEditorMonthlyRepeatOn=N;exports.recurrenceEditorOffsetPositionsFirst=Q;exports.recurrenceEditorOffsetPositionsFourth=_;exports.recurrenceEditorOffsetPositionsLast=$;exports.recurrenceEditorOffsetPositionsSecond=U;exports.recurrenceEditorOffsetPositionsThird=X;exports.recurrenceEditorRepeat=q;exports.recurrenceEditorWeekdaysDay=ee;exports.recurrenceEditorWeekdaysWeekday=re;exports.recurrenceEditorWeekdaysWeekendday=te;exports.recurrenceEditorWeeklyInterval=Y;exports.recurrenceEditorWeeklyRepeatEvery=Z;exports.recurrenceEditorWeeklyRepeatOn=I;exports.recurrenceEditorYearlyInterval=z;exports.recurrenceEditorYearlyOf=L;exports.recurrenceEditorYearlyRepeatEvery=x;exports.recurrenceEditorYearlyRepeatOn=j;exports.showFullDay=E;exports.showWorkDay=y;exports.timeTitle=Te;exports.timelineViewTitle=n;exports.today=t;exports.weekViewTitle=c;exports.workWeekViewTitle=i;
